VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSEEigenschaften"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Copyright (C) 2003  Jrgen Niesner, Stefan Rhrl
'This program is free software; you can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the
'License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================
Option Explicit
Option Base 1

Public Function liefereDISNummer(SeDokument As Object) As String
    Dim sWert As String
    Err.Clear
    On Error Resume Next
        sWert = lieferePropertie(SeDokument, "Custom", "SAPType") + " " + _
                    Right(lieferePropertie(SeDokument, "Custom", "SAPName"), 7) + " " + _
                    lieferePropertie(SeDokument, "Custom", "SAPPart") + " " + _
                    lieferePropertie(SeDokument, "Custom", "SAPVersion")
    On Error GoTo 0
    If (Err = False) And (sWert <> "") Then
        liefereDISNummer = sWert
        Exit Function
    Else
        Err.Clear
    End If
    'wenn die Funktion bis hierher luft ist ein Problem aufgetreten
    liefereDISNummer = ""
'    Call Err.Raise(1, "liefereDISNummer", "Im bergebenen Se-Dokument konnte keine DIS-Nummer gefunden werden")
End Function

Public Function liefereBenennung(SeDokument As Object) As String
    Dim sWert As String
    Err.Clear
    On Error Resume Next
        sWert = lieferePropertie(SeDokument, "Custom", "SAPDescription")
    On Error GoTo 0
    If (Err = False) And (sWert <> "") Then
        liefereBenennung = sWert
        Exit Function
    Else
        Err.Clear
    End If
    On Error Resume Next
        sWert = lieferePropertie(SeDokument, "Project", "ProjectName")
    On Error GoTo 0
    If (Err = False) And (sWert <> "") Then
        liefereBenennung = sWert
        Exit Function
    Else
        Err.Clear
    End If
    'wenn die Funktion bis hierher luft ist ein Problem aufgetreten
    liefereBenennung = ""
'    Call Err.Raise(1, "liefereBenennung", "Im bergebenen Se-Dokument konnte keine Benennung gefunden werden")
End Function

Public Function liefereMaterialNummer(SeDokument As Object) As String
    Dim sWert As String
    Err.Clear
    On Error Resume Next
        sWert = lieferePropertie(SeDokument, "Custom", "DRAWING-MARA-MATNR")
    On Error GoTo 0
    If (Err = False) And (sWert <> "") Then
        liefereMaterialNummer = sWert
        Exit Function
    Else
        Err.Clear
    End If
'    On Error Resume Next
'        sWert = lieferePropertie(SeDokument, "Custom", "MR_Materialnummer")
'    On Error GoTo 0
'    If (Err = False) And (sWert <> "") Then
'        liefereMaterialNummer = sWert
'        Exit Function
'    Else
'        Err.Clear
'    End If
'    On Error Resume Next
'        sWert = lieferePropertie(SeDokument, "Custom", "MR_Sachnummer")
'    On Error GoTo 0
'    If (Err = False) And (sWert <> "") Then
'        liefereMaterialNummer = sWert
'        Exit Function
'    Else
'        Err.Clear
'    End If
    
    On Error Resume Next
        sWert = lieferePropertie(SeDokument, "ProjectInformation", "DokumentNummer")
    On Error GoTo 0
    If (Err = False) And (sWert <> "") Then
        liefereMaterialNummer = sWert
        Exit Function
    Else
        Err.Clear
    End If
    On Error Resume Next
        sWert = lieferePropertie(SeDokument, "ProjectInformation", "DokumentNummer")
    On Error GoTo 0
    If (Err = False) And (sWert <> "") Then
        liefereMaterialNummer = sWert
        Exit Function
    Else
        Err.Clear
    End If
    On Error Resume Next
        sWert = lieferePropertie(SeDokument, "ProjectInformation", "Document Number")
    On Error GoTo 0
    If (Err = False) And (sWert <> "") Then
        liefereMaterialNummer = sWert
        Exit Function
    Else
        Err.Clear
    End If
    'wenn die Funktion bis hierher luft ist ein Problem aufgetreten
    liefereMaterialNummer = ""
'    Call Err.Raise(1, "liefereMaterialNummer", "Im bergebenen Se-Dokument konnte keine Materialnummer gefunden werden")
End Function

Public Function lieferePropertie(ByRef SeDokument As Object, _
            ByVal sPropertySet As String, ByVal sPropertyName As String) As String
    Dim PropSets As SolidEdgeFramework.PropertySets
    Dim Properties As SolidEdgeFramework.Properties
    Dim sWert As String
    Err.Clear
    On Error Resume Next
        Set PropSets = SeDokument.Properties
        Set Properties = PropSets(sPropertySet)                             ' richtige Eigenschaftenseite ffnen
        sWert = CStr(Properties.Item(sPropertyName).Value)
        If Err Then
            lieferePropertie = ""
            Call Err.Raise(Err.Number, Err.Source, Err.Description)
            Err.Clear
        Else
            lieferePropertie = sWert
        End If
    On Error GoTo 0
    Set Properties = Nothing
    Set PropSets = Nothing
End Function

Public Sub schreibePropertie(ByRef SeDokument As Object, _
            ByVal sPropertySet As String, ByVal sPropertyName As String, ByVal sWert As String)
    Dim PropSets As SolidEdgeFramework.PropertySets
    Dim Properties As SolidEdgeFramework.Properties
    Dim sTestWert As String
    Err.Clear
    On Error Resume Next
        Set PropSets = SeDokument.Properties
        Set Properties = PropSets(sPropertySet)                             ' richtige Eigenschaftenseite ffnen
'        sTestWert = Properties.Item(sPropertyName).Value
        Properties.Item(sPropertyName).Value = sWert
        If Err Then
            Err.Clear
            Call Properties.Add(sPropertyName, sWert)
            If Err Then
                MsgBox "E " & Err.Number & " " & Err.Description
                Call Err.Raise(Err.Number, Err.Source, Err.Description)
                Err.Clear
            End If
        End If
    On Error GoTo 0
    Set Properties = Nothing
    Set PropSets = Nothing
End Sub
